import java.applet.*;
import java.awt.*;
// import java.awt.Color.*;

/** This class defines a frame and the components in the frame,
	including choice, list, checkbox, button, panel */
public class hmwk3 extends Applet{
//public class hmwk3 extends Applet{
Button	Brst, Bsmall, Blarge, Bquit;

List gridsList;
Choice colorChoice, iterNumChoice;
CheckboxGroup sizeCheckGroup;	Checkbox[] sizeCheck;
// Scrollbar timesScroll;
// int max = 10000;

Panel	panel1, panel2;
Panel	buttonpanel;

jacoGraph	jacoGrph;

GridBagLayout gridbag = new GridBagLayout();
GridBagConstraints gbc;

int		iterNum = 20;

/** Constructor. This method initialize all the components
	in the frame and arrange them */
public hmwk3() 
// public void init()
{
	colorChoice = new Choice();
	colorChoice.addItem("Red");
	colorChoice.addItem("Green");
	colorChoice.addItem("Blue");
	// colorChoice.addItemListener(this);

	sizeCheckGroup = new CheckboxGroup();
	sizeCheck = new Checkbox[4];
	sizeCheck[0] = new Checkbox("Tiny",sizeCheckGroup,false);
	sizeCheck[1] = new Checkbox("Small",sizeCheckGroup,true);
	sizeCheck[2] = new Checkbox("Medium",sizeCheckGroup,false);
	sizeCheck[3] = new Checkbox("Large",sizeCheckGroup,false);

	gridsList = new List(4,true);
	gridsList.addItem("4 * 4");
	gridsList.addItem("8 * 8");
	gridsList.addItem("16 * 16");
	gridsList.addItem("32 * 32");

	Brst = new Button("Restart");
	// Brun = new Button("Run");
	// Bstop = new Button("Stop");
	Bsmall = new Button("Zoom <<");
	Blarge = new Button("Zoom >>");
	Bquit = new Button("Quit");

	panel1 = new Panel();
	panel1.setLayout(gridbag);

	constrain(panel1, new Label("Color"), 0,0,1,1);
	constrain(panel1, colorChoice, 0,1,1,1);
	constrain(panel1, new Label("Size"),0,2,1,1,10,0,0,0);
	constrain(panel1, sizeCheck[0],0,3,1,1);
	constrain(panel1, sizeCheck[1],0,4,1,1);
	constrain(panel1, sizeCheck[2],0,5,1,1);
	constrain(panel1, sizeCheck[3],0,6,1,1);
	constrain(panel1, new Label("Grids"),0,7,1,1,10,0,0,0);
	constrain(panel1, gridsList,0,8,1,3,GridBagConstraints.VERTICAL,
			GridBagConstraints.NORTHWEST,0.0,1.0,0,0,0,0);

	iterNumChoice = new Choice();
	iterNumChoice.addItem("20");
	iterNumChoice.addItem("40");
	iterNumChoice.addItem("60");
	iterNumChoice.addItem("80");

	jacoGrph = new jacoGraph();

	panel2 = new Panel();
	panel2.setLayout(gridbag);

	constrain(panel2, new Label("Iteration Times Choice"),0,0,1,1);
	constrain(panel2, iterNumChoice, 0,1,1,1,GridBagConstraints.NONE,
		GridBagConstraints.WEST, 0.,0.,0,0,0,0);
	constrain(panel2, new Label("Jacobi Iteration"),0,2,1,1);
	constrain(panel2, jacoGrph, 0,4,1,1,GridBagConstraints.BOTH,
		GridBagConstraints.CENTER, 1.0,1.0,0,0,0,0);

	buttonpanel = new Panel();
	buttonpanel.setLayout(new FlowLayout());
	buttonpanel.setLayout(gridbag);
	constrain(buttonpanel,Brst,0,0,1,2,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0);
	/* constrain(buttonpanel,Brun,1,0,1,1,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0);
	constrain(buttonpanel,Bstop,2,0,1,1,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0); */
	constrain(buttonpanel,Bsmall,1,0,1,2,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0);
	constrain(buttonpanel,Blarge,2,0,1,2,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0);
	constrain(buttonpanel,Bquit,3,0,1,2,GridBagConstraints.NONE,
		GridBagConstraints.CENTER,0.3,0.0,0,0,0,0);

	this.setLayout(gridbag);
	constrain(this,panel1,0,0,1,1,GridBagConstraints.VERTICAL,
		GridBagConstraints.NORTHWEST,0.0,1.0,10,10,5,5);
	constrain(this,panel2,1,0,1,1,GridBagConstraints.BOTH,
		GridBagConstraints.NORTHEAST,1.0,1.0,10,10,5,5);
	constrain(this,buttonpanel,0,1,2,1,GridBagConstraints.HORIZONTAL,
		GridBagConstraints.CENTER,1.0,0.0,5,0,0,0);
}

/** This is the main constrain method. It setup the layout in the frame, 
	It has arguments for all constraints
	This method specifies the position of a component that can grow, and
	 does have margins */ 
public void constrain(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height,
	int fill, int anchor, double weight_x, double weight_y,
	int top, int left, int bottom, int right)
{
	GridBagConstraints c = new GridBagConstraints();
	c.gridx = grid_x; c.gridy = grid_y;
	c.gridwidth = grid_width; c.gridheight = grid_height;
	c.fill = fill; c.anchor = anchor;
	c.weightx = weight_x; c.weighty = weight_y;
	if(top + bottom + left + right > 0)
		c.insets = new Insets(top, left, bottom, right);
	((GridBagLayout)container.getLayout()).setConstraints(component, c);
	container.add(component);
}

/** This method specifies the position of a component that does
	not grow and does not have margins */ 
public void constrain(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height)
{
	constrain(container, component, grid_x, grid_y,
		grid_width,grid_height, GridBagConstraints.NONE,
		GridBagConstraints.NORTHWEST, 0.0,0.0,0,0,0,0);
}

/** This method specifies the position of a component that does
	not grow, but does have margins */ 
public void constrain(Container container, Component component,
	int grid_x, int grid_y, int grid_width, int grid_height,
	int top, int left, int bottom, int right)
{
	constrain(container, component, grid_x, grid_y,
		grid_width,grid_height, GridBagConstraints.NONE,
		GridBagConstraints.NORTHWEST, 0.0,0.0,top,left,bottom,right);
}

/** This method handles all the events generated by all the 
	components */
public boolean handleEvent(Event event)
{
	switch(event.id) {
	case Event.ACTION_EVENT:
		if(event.target == sizeCheck[0]) {
			jacoGrph.setRectSize(8);	
		} else if(event.target == sizeCheck[1]) {
			jacoGrph.setRectSize(16);	
		} else if(event.target == sizeCheck[2]) {
			jacoGrph.setRectSize(32);	
		} else if(event.target == sizeCheck[3]) {
			jacoGrph.setRectSize(64);	
		} else if (event.target == colorChoice) {
			jacoGrph.setClrChoice(colorChoice.getSelectedIndex());
		} else if (event.target == iterNumChoice) {
			this.setIterNumChoice((iterNumChoice.getSelectedIndex()+1) * 20);
		} else if (event.target == Brst) {
			jacoGrph.jacoInit();
			for (int l = 0; l < this.iterNum; l++){
				jacoGrph.rst(this.iterNum);
				jacoGrph.repaint();
			}
		} else if (event.target == Bsmall) {
			jacoGrph.setRectSize(jacoGrph.currentRectSize() / 2);
		} else if (event.target == Blarge) {
			jacoGrph.setRectSize(jacoGrph.currentRectSize() * 2);
		} else if (event.target == Bquit) {
			System.exit(0);
		}
		break;
	case Event.LIST_SELECT:
		if(event.target == gridsList)
		jacoGrph.setGridSize((((Integer) event.arg).intValue() + 1) * 4,
			(((Integer) event.arg).intValue() + 1) * 4);
	case Event.LIST_DESELECT:
		break;
	case Event.WINDOW_DESTROY:
		break;
	case Event.WINDOW_ICONIFY:
		break;
	case Event.WINDOW_DEICONIFY:
		break;
	case Event.WINDOW_MOVED:
		break;
	case Event.MOUSE_DOWN:
		break;
	case Event.MOUSE_UP:
		break;
	}
	return true;
}

/** This method specifies the times of Jacobi Iteration */
public void setIterNumChoice(int Times)
{
	this.iterNum = Times;
}

/* public static void main (String[] args)
{
	Frame f = new hmwk3();
	f.pack();
	f.show();
} */

}
